unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, cases, Menus, About;

const
  Product_Name='Ascendancy SHP Converter';
  Product_Version='v1.0';
  Product_Data='24.10.2001';
  Author_Name=' ';
  Author_EMail='collapse_forever@mail.ru';
  Author_http='termius.narod.ru';

type
  T4Array=array[1..4]of char;
  TPalette=array[0..255]of record
                             R,G,B,F: Byte;
                           end;
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DriveComboBox1: TDriveComboBox;
    Panel3: TPanel;
    FilterComboBox1: TFilterComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function LoadPalette(FName: string; Invert: Boolean; var Pal: TPalette): Boolean;
  procedure Expand(SByte: Byte; var SType,SLength: Byte);
  procedure ClearSprites;

var
  idSHP: T4Array=('1','.','1','0');
  Form1: TForm1;
  TotalSprites: LongInt;
  CurDir: string;
  Entries: array of LongInt;
  Sprites: array of TMemoryStream;
  BmpID: ARRAY[1..2]OF Char;
  BMPPalette: TPalette;
  BMPHeader: RECORD
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;     //DataSize=X*Y+2*Y
               DataSize2: LongInt;     //DataSize=X*Y+2*Y
               _C5: ARRAY[1..8]OF Byte;
             END;

implementation

{$R *.DFM}

procedure Expand(SByte: Byte; var SType,SLength: Byte);
begin
  SType:=SByte and $01;
  SLength:=SByte shr 1;
end;

procedure ClearSprites;
var
  i: LongInt;
begin
  if TotalSprites=0 then Exit;
  for i:=1 to TotalSprites do Sprites[i-1].Free;
  TotalSprites:=0;
  SetLength(Sprites,TotalSprites);
end;

function LoadPalette(FName: string; Invert: Boolean; var Pal: TPalette): Boolean;
var
  F: TFileStream;
  i: Byte;
begin
  if not(FileExists(FName))then
  begin
    LoadPalette:=False;
    Exit;
  end;
  LoadPalette:=True;
  F:=TFileStream.Create(FName,fmOpenRead);
//  F.Seek($08,soFromBeginning);
  for i:=0 to 255 do
  begin
    if Invert then
    begin
      F.Read(Pal[i].B,1);
      F.Read(Pal[i].G,1);
      F.Read(Pal[i].R,1);
    end else
    begin
      F.Read(Pal[i].R,1);
      F.Read(Pal[i].G,1);
      F.Read(Pal[i].B,1);
    end;
    Pal[i].R:=Pal[i].R*4;
    Pal[i].G:=Pal[i].G*4;
    Pal[i].B:=Pal[i].B*4;
    Pal[i].F:=$00;
  end;
  F.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadPalette('game.pal',True,BMPPalette);
  BmpID[1]:='B';
  BmpID[2]:='M';
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  TotalSprites:=0;
  GetDir(0,CurDir);
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
var
  FSHP,FMem: TMemoryStream;
  FName: string;
  Tid: T4Array;
  i,TotalRowWidth: LongInt;
  SWidth,SHeight,SLeft,STop: Word;
  FreeBuffer,Buffer: array[1..640]of char;
  y,z,MaxY: LongInt;
  SByte,SType,SLength,Add: Byte;
begin
  ListBox1.Color:=clBtnFace;
  ListBox1.Items.Clear;
  ListBox1.Refresh;
  ClearSprites;
  if FileListBox1.ItemIndex=-1 then Exit;
  FName:=FileListBox1.FileName;
  FSHP:=TMemoryStream.Create;
  FSHP.LoadFromFile(FName);
  FSHP.Read(Tid,4);
  if not (Tid=idSHP) then
  begin
    ShowMessage(' SHP !');
    FSHP.Free;
    Exit;
  end;
  FSHP.Seek($04,soFromBeginning);
  FSHP.Read(TotalSprites,4);
  SetLength(Entries,TotalSprites);
  SetLength(Sprites,TotalSprites);
  for i:=1 to TotalSprites do
  begin
    FSHP.Read(Entries[i-1],4);
    FSHP.Seek($04,soFromCurrent);
  end;
  {***  }
  FillChar(FreeBuffer,640,#00);
  for i:=1 to TotalSprites do
  begin
    FSHP.Seek(Entries[i-1],soFromBeginning);
    FSHP.Read(SHeight,2);
    FSHP.Read(SWidth,2);
    FSHP.Read(STop,2);
    FSHP.Read(SLeft,2);
    FSHP.Seek(16,soFromCurrent);
    SWidth:=SWidth+1;
    SHeight:=SHeight+1;
{    SWidth:=SWidth+SLeft+1;
    SHeight:=SHeight+STop+1;}
    Add:=Round(Int((4*(1-(Frac(SWidth/4))))));
    if Add=4 then Add:=0;
    BMPHeader.x:=SWidth;
    BMPHeader.y:=SHeight;
    BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
    BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
    BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
    BMPHeader._H3:=$00;
    Sprites[i-1]:=TMemoryStream.Create;
    Sprites[i-1].Write(BmpID,2);
    Sprites[i-1].Write(BMPHeader,SizeOf(BMPHeader));
    Sprites[i-1].Write(BMPPalette,1024);
    FMem:=TMemoryStream.Create;
    for y:=1 to SHeight do
    begin
      TotalRowWidth:=0;
      repeat
        FSHP.Read(SByte,1);
        Expand(SByte,SType,SLength);
        if SByte>0 then
        case SType of
        0:begin
            FSHP.Read(Buffer[1],1);
            FillChar(Buffer,SLength,Buffer[1]);
            FMem.Write(Buffer,SLength);
            TotalRowWidth:=TotalRowWidth+SLength;
          end;
        1:begin
            if SLength>0 then
            begin
              FSHP.Read(Buffer,SLength);
              FMem.Write(Buffer,SLength);
              TotalRowWidth:=TotalRowWidth+SLength;
            end else
            begin
              FSHP.Read(SLength,1);
              FMem.Write(FreeBuffer,SLength);
              TotalRowWidth:=TotalRowWidth+SLength;
            end;
          end;
        end;
      until (SByte=0)or(FSHP.Position=FSHP.Size);
      if TotalRowWidth<SWidth then FMem.Write(FreeBuffer,SWidth-TotalRowWidth);
      if Add>0 then FMem.Write(FreeBuffer,Add);
      if FSHP.Position=FSHP.Size then Break else
      if i<TotalSprites then
      if FSHP.Position=Entries[i] then Break;
    end;
    MaxY:=y;
    for y:=1 to MaxY do
    begin
      FMem.Seek((MaxY-y)*(SWidth+Add),soFromBeginning);
      Sprites[i-1].CopyFrom(FMem,SWidth+Add);
    end;
    if MaxY<SHeight then
    for z:=MaxY to SHeight do Sprites[i-1].Write(FreeBuffer,SWidth+Add);
    Sprites[i-1].Seek(0,soFromBeginning);
    FMem.Free;
    ListBox1.Items.Add(IntToStr(i));
  end;
  FSHP.Free;
  ListBox1.Color:=clWindow;
  ListBox1.ItemIndex:=0;
  ListBox1.OnClick(Self);
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex=-1 then Exit;
  Sprites[ListBox1.ItemIndex].Seek(0,soFromBeginning);
  Image1.Picture.Bitmap.LoadFromStream(Sprites[ListBox1.ItemIndex]);
end;

procedure TForm1.Image1Click(Sender: TObject);
var
  tt: string;
begin
  tt:=ExtractFileName(FileListBox1.FileName);
  if Pos('.',tt)>0 then tt:=Copy(tt,1,Pos('.',tt)-1);
  SaveDialog1.FileName:=CurDir+'\'+tt+BuildStr(IntToStr(ListBox1.ItemIndex+1),'0',3);
  if SaveDialog1.Execute then
  begin
    Image1.Picture.Bitmap.SaveToFile(SaveDialog1.FileName);
    CurDir:=Copy(ExtractFilePath(SaveDialog1.FileName),1,Length(ExtractFilePath(SaveDialog1.FileName))-1);
  end;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  ShowAbout(Product_Name,Product_Version,Product_Data,Author_Name,Author_EMail,Author_http);
end;

end.
